// CalendarDlg.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "CalendarDlg.h"
#include "MainFrm.h"
#include "DaysEaseView.h"
#include "DaysEaseDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CCalendarDlg dialog


CCalendarDlg::CCalendarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalendarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalendarDlg)
	//}}AFX_DATA_INIT
}


void CCalendarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalendarDlg)
	DDX_Control(pDX, IDC_TEXTCHECK, m_TextCheck);
	DDX_Control(pDX, IDC_CANCELNOTE, m_CancelNote);
	DDX_Control(pDX, IDC_WKDSWAP, m_wkdSwap);
	DDX_Control(pDX, IDC_YEAR, m_Year);
	DDX_Control(pDX, IDC_ORIENTATION, m_Orientation);
	DDX_Control(pDX, IDC_DAYNOTE, m_DayNote);
	DDX_Control(pDX, IDC_DAYNUM, m_DayNum);
	DDX_Control(pDX, IDC_BTNMONTH, m_btnMonth);
	DDX_Control(pDX, IDC_6X2, m_6x2);
	DDX_Control(pDX, IDC_2X6, m_2x6);
	DDX_Control(pDX, IDC_4X3, m_4x3);
	DDX_Control(pDX, IDC_3X4, m_3x4);
	DDX_Control(pDX, IDC_ARRANGE, m_Arrange);
	DDX_Control(pDX, IDC_MONTH, m_Month);
	DDX_Control(pDX, IDC_ENTER, m_Enter);
	DDX_Control(pDX, IDC_DATA, m_Data);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCalendarDlg, CDialog)
	//{{AFX_MSG_MAP(CCalendarDlg)
	ON_BN_CLICKED(IDC_2X6, On2x6)
	ON_BN_CLICKED(IDC_3X4, On3x4)
	ON_BN_CLICKED(IDC_4X3, On4x3)
	ON_BN_CLICKED(IDC_6X2, On6x2)
	ON_BN_CLICKED(IDC_BTNMONTH, OnBtnmonth)
	ON_EN_CHANGE(IDC_DATA, OnChangeData)
	ON_BN_CLICKED(IDC_HORIZF, OnHorizf)
	ON_BN_CLICKED(IDC_HORIZH, OnHorizh)
	ON_BN_CLICKED(IDC_ORIENTATION, OnOrientation)
	ON_CBN_SELCHANGE(IDC_MONTH, OnSelchangeMonth)
	ON_CBN_SELCHANGE(IDC_YEAR, OnSelchangeYear)
	ON_BN_CLICKED(IDC_VERTF, OnVertf)
	ON_BN_CLICKED(IDC_VERTH, OnVerth)
	ON_BN_CLICKED(IDC_WKDSWAP, OnWkdswap)
	ON_BN_CLICKED(IDC_CANCELNOTE, OnCancelnote)
	ON_EN_MAXTEXT(IDC_DATA, OnMaxtextData)
	ON_BN_CLICKED(IDC_ENTER, OnEnter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalendarDlg message handlers

BOOL CCalendarDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString year;
	CRect rect;
	char ch[5];

	// Fill the Year combo box list
	for(int i = 1970; i < 2038; i++)
	{
		itoa(i, ch, 10);
		year = ch;
		m_Year.AddString(year);
	}
	// Create a margin for the Day Notes edit box by deflating its client area
	m_Data.GetRect(rect);
	rect.DeflateRect(5, 5);
	m_Data.SetRect(rect);
	// Set a tab stop for the Day Notes edit box and its associated Text Check edit box
	// so the Day Number can be easily located on the right.
	// Note that the Text Check edit box is onlt visible when the user right clicks on a Day box.
	TEXTMETRIC tx;
	HDC hDC = CreateDC("DISPLAY", NULL, NULL, NULL);
	GetTextMetrics(hDC, &tx);
	int width = tx.tmAveCharWidth;
	// The calculation for width was obtained through trial and error.
	width = ((rect.Width()/width))*4;
	m_Data.SetTabStops(width);
	m_TextCheck.GetRect(rect);
	rect.DeflateRect(5, 5);
	m_TextCheck.SetRect(rect);
	m_TextCheck.SetTabStops(width);
	// Limit the text for the Day Notes edit box so it can't be overfilled
	// by a large paste from the clipboard.
	m_Data.SetLimitText(MAX_NOTE);
	// Delete the device context to free memory
	DeleteDC(hDC);
	// Set the default Arrange radio button.
	m_3x4.SetCheck(1);
	nYrx = 3;
	nYry = 4;

	return TRUE;
}
// Handlers for the Arrange radio button group.
void CCalendarDlg::On2x6() 
{
	nYrx = 2;
	nYry = 6;
	theApp.Update_View();
}

void CCalendarDlg::On3x4() 
{
	nYrx = 3;
	nYry = 4;
	theApp.Update_View();
}

void CCalendarDlg::On4x3() 
{
	nYrx = 4;
	nYry = 3;
	theApp.Update_View();
}

void CCalendarDlg::On6x2() 
{
	nYrx = 6;
	nYry = 2;
	theApp.Update_View();
}

// Handler for the Year/Month button.
void CCalendarDlg::OnBtnmonth() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	CMainFrame* pMain = theApp.Main_Pointer();
	BOOL trufal(0);
	CString DocName;

	// Display the common Save dialog if needed and
	// return without doing anything if the user selects Cancel.
	if(pDoc->IsModified())
		if(!pDoc->SaveModified())
			return;
	// If our Year/Month mode flag is set, then we are switching from
	// Year to Month mode.
	if(pDoc->fMonYr)
	{
		// Clear the mode flag.
		pDoc->fMonYr = 0;
		// Set our Edit flag so the Day Notes edit box will update.
		pView->fEdit++;
		// Set our Events flag so the Events update.
		pView->fEvents++;
		// See if we have a Year document file loaded.
		DocName = pDoc->GetPathName();
		// If so, save the file name in DaysEase.ini.
		if(!DocName.IsEmpty())
			theApp.WriteProfileString("DaysEase", "Year Doc", DocName);
		// Dump the current data.
		Clear_All();
		// See if DaysEase.ini has a Month document file saved.
		DocName = theApp.GetProfileString("DaysEase", "Month Doc", "");
		// If not, set nMonth to zero so the view will know to
		// start fresh with todays date.
		if(DocName.IsEmpty())
		{
			pDoc->nMonth = 0;
			Display_Month_Page();
		}
		// If DaysEase.ini has a Month document file saved, load it.
		// Note that loading a Month document automatically
		// calls Display_Month_Page().
		else
			trufal = pDoc->OnOpenDocument(DocName);
	}
	// If our Year/Month mode flag is not set, then we are switching from
	// Month to Year mode.
	else
	{
		// Set the mode flag
		pDoc->fMonYr++;
		// See if we have a Month document file loaded.
		DocName = pDoc->GetPathName();
		// If so, save the file name in DaysEase.ini.
		if(!DocName.IsEmpty())
			theApp.WriteProfileString("DaysEase", "Month Doc", DocName);
		// Dump the current data.
		Clear_All();
		// See if DaysEase.ini has a Year document file saved.
		DocName = theApp.GetProfileString("DaysEase", "Year Doc", "");
		// If not, just switch to Year mode.
		if(DocName.IsEmpty())
			Display_Year_Page();
		// If DaysEase.ini has a Year document file saved, load it.
		// Note that loading a Year document automatically
		// calls Display_Year_Page().
		else
			trufal = pDoc->OnOpenDocument(DocName);
	}

	// Clear our New Document flag and call OnNewDocument()
	// to reinitialize our only document.
	pDoc->fNewDoc = 0;
	pDoc->OnNewDocument();
	// If we loaded a document set the file path and call the View's
	// OnInitialUpdate(), since OnOpenDocument() doesn't do it automatically.
	if(trufal)
	{
		pDoc->SetPathName(DocName, TRUE);
		pView->OnInitialUpdate();
	}
	// Otherwise, just reset our New Document flag.
	else
		pDoc->fNewDoc++;
	// Update the View.
	theApp.Update_View();
}

// Switch to Month mode
void CCalendarDlg::Display_Month_Page()
{
	CMainFrame* pMain = theApp.Main_Pointer();
	// Show or hide the appropriate controls
	m_Enter.ShowWindow(SW_SHOW);
	m_Month.ShowWindow(SW_SHOW);
	m_Data.ShowWindow(SW_SHOW);
	m_DayNum.ShowWindow(SW_SHOW);
	m_DayNote.ShowWindow(SW_SHOW);
	m_CancelNote.ShowWindow(SW_SHOW);
	m_Arrange.ShowWindow(SW_HIDE);
	m_wkdSwap.ShowWindow(SW_SHOW);
	m_3x4.ShowWindow(SW_HIDE);
	m_2x6.ShowWindow(SW_HIDE);
	m_4x3.ShowWindow(SW_HIDE);
	m_6x2.ShowWindow(SW_HIDE);
	// Set appropriate control text
	m_btnMonth.SetWindowText("Year");
	pMain->m_StyleDlg.m_wkdMonth.SetWindowText("Days of the Week");
	pMain->m_StyleDlg.m_Text.SetWindowText("Day Notes");
	if(theApp.nDateSwap)
		pMain->m_StyleDlg.m_MonYr.SetWindowText("Year and Month");
	else
		pMain->m_StyleDlg.m_MonYr.SetWindowText("Month and Year");
	// Enable the appropriate controls
	pMain->m_StyleDlg.m_Split.EnableWindow(TRUE);
	pMain->m_StyleDlg.m_Swap.EnableWindow(TRUE);
	pMain->m_StyleDlg.m_NoteLarge.EnableWindow(TRUE);
	// Get the date style position radio button setting from DaysEase.ini
	theApp.nDt_Custom = theApp.GetProfileInt("DaysEase", "Date Style", DT_CENTER);
	// Set the date style position radio buttons
	pMain->m_StyleDlg.Set_Date_Style();
}

// Switch to Year mode
void CCalendarDlg::Display_Year_Page()
{
	CMainFrame* pMain = theApp.Main_Pointer();
	// Show or hide the appropriate controls
	m_Enter.ShowWindow(SW_HIDE);
	m_Month.ShowWindow(SW_HIDE);
	m_Data.ShowWindow(SW_HIDE);
	m_DayNum.ShowWindow(SW_HIDE);
	m_DayNote.ShowWindow(SW_HIDE);
	m_CancelNote.ShowWindow(SW_HIDE);
	m_wkdSwap.ShowWindow(SW_HIDE);
	m_Arrange.ShowWindow(SW_SHOW);
	m_3x4.ShowWindow(SW_SHOW);
	m_2x6.ShowWindow(SW_SHOW);
	m_4x3.ShowWindow(SW_SHOW);
	m_6x2.ShowWindow(SW_SHOW);
	// If the Split date style position radio button is set,
	// change it to center, since Split is disabled.
	if(pMain->m_StyleDlg.m_Split.GetCheck())
	{
		pMain->m_StyleDlg.m_Split.SetCheck(0);
		theApp.nDt_Custom = DT_CENTER;
	}
	// Set appropriate control text
	m_btnMonth.SetWindowText("Month");
	pMain->m_StyleDlg.m_wkdMonth.SetWindowText("Months");
	pMain->m_StyleDlg.m_MonYr.SetWindowText("Year");
	pMain->m_StyleDlg.m_Text.SetWindowText("Days");
	// Enable the appropriate controls
	pMain->m_StyleDlg.m_Split.EnableWindow(FALSE);
	pMain->m_StyleDlg.m_Swap.EnableWindow(FALSE);
	pMain->m_StyleDlg.m_NoteLarge.EnableWindow(FALSE);
	// Set the date style position radio buttons
	pMain->m_StyleDlg.Set_Date_Style();
}

// Handler for text changes to the Day Note edit box.
void CCalendarDlg::OnChangeData() 
{
	int start, end;

// Check to see if the caret is on the first line.
// If so, then the user deleted the line return by backspacing,
// so replace the line return.
	m_Data.GetSel(start, end);
	if(m_Data.LineFromChar(start) == 0)
		m_Data.ReplaceSel(CString(0x0d) + CString(0x0a));
	// See if the Day Box is full
	Check_DayNote_Text();
	// Set our fNote flag so the change will be saved to the document.
	theApp.View_Pointer()->fNote++;
}

// Handler for the Day Notes Enter button.
void CCalendarDlg::OnEnter() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	CString New_Data, Old_Data;

	// Get the current text from the Day Notes edit box
	m_Data.GetWindowText(New_Data);
	// Get the current text from calendar Day Box, which is the same as stored in the document.
	Old_Data = pDoc->GetSquare(pView->nCurX, pView->nCurY);
	// Make sure the text has actually changed before setting the document Modified flag.
	if(New_Data != Old_Data)
	{
		pDoc->Add_Data(New_Data, pView->nCurX, pView->nCurY);
		theApp.Set_Modified_Flag();
		pView->InvalidateRect(pView->m_rect[pView->nCurX][pView->nCurY]);
	}
	// Clear our fNote flag to indicate the the Day Note has been saved.
	pView->fNote = 0;
}

// Handler for the Full Width button.
void CCalendarDlg::OnHorizf() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	// Set the calendar right and left sides equal to the printable page borders,
	// correcting for present client window size.
	pDoc->ratio_left = theApp.page_rect.left/pView->dCW;
	pDoc->ratio_right = theApp.page_rect.right/pView->dCW;
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}

// Handler for the Half Width button.
void CCalendarDlg::OnHorizh() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	// Set the calendar width equal to half the printable page width.
	pView->m_calendar.m_rect.right = pView->m_calendar.m_rect.left +
					theApp.page_rect.Width()/2;
	// Set the document ratio to the new value, correcting for present client window size.
	pDoc->ratio_right = pView->m_calendar.m_rect.right/pView->dCW;
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for the Portrait/Landscape button.
void CCalendarDlg::OnOrientation() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	// Check the current orientation and change it,
	// updating the button text accordingly.
	if(theApp.Orientation == DMORIENT_LANDSCAPE)
	{
		theApp.Orientation = DMORIENT_PORTRAIT;
		m_Orientation.SetWindowText("Landscape");
	}
	else
	{
		theApp.Orientation = DMORIENT_LANDSCAPE;
		m_Orientation.SetWindowText("Portrait");
	}
	// Update the document.
	pDoc->Orientation = theApp.Orientation;
	// Update the printer settings and reset, so that it re-reads all affected values.
	pView->m_pPrintDialog->GetDevMode()->dmOrientation = theApp.Orientation;
	ResetDC(pView->m_pPrintDialog->m_pd.hDC, pView->m_pPrintDialog->GetDevMode());
	// Update the View with the new printer settings.
	pView->Get_Printer_Stats(pView->m_pPrintDialog->m_pd.hDC);
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
	// Write the present Orientation to DaysEase.ini.
	theApp.WriteProfileInt(theApp.PrinterName, "Orientation", theApp.Orientation);
}
// Handler for the Month combo box.
void CCalendarDlg::OnSelchangeMonth() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	if(pDoc->IsModified())
		if(!pDoc->SaveModified())
		{
			m_Month.SetCurSel(pDoc->nMonth -1);
			return;
		}
	// Call OnNewDocument() to reinitialize our only document.
	pDoc->OnNewDocument();
	// Set the document month to the zero based value selected in the combo box plus one.
	pDoc->nMonth = m_Month.GetCurSel() + 1;
	// Dump all data and invalidate the View.
	Clear_All();
	// Set our View flags to read new data.
	pDoc->fNewDoc++;
	pView->fEdit++;
	pView->fEvents++;
}

// Dump document data and View data.
void CCalendarDlg::Clear_All()
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	int row;
	int col;

	// Set the document Day Notes and Events to NULL.
	for(row = 0; row < 6; row++)
		for(col = 0; col < 7; col++)
			pDoc->Add_Data("", col, row);
	theApp.Empty_Event_Array();
	// Since the Day Box at row 5 and col 6 is never used,
	// setting nCurX and nCurY to those values ensures that
	// they must be recalculated.
	pView->nCurX = col;
	pView->nCurY = row;
	// Set the day to the first of the month.
	pView->nDay = 1;
	// Empty the Day Notes edit box, so that it must be rewritten.
	m_Data.SetWindowText("");
	// Invalidate the View, so that it gets redrawn with the next WM_PAINT.
	theApp.Update_View();
}

// Handler for the Year combo box.
void CCalendarDlg::OnSelchangeYear() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	if(pDoc->IsModified())
		if(!pDoc->SaveModified())
		{
			m_Year.SetCurSel(pDoc->nYear -1970);
			return;
		}
	pDoc->SetModifiedFlag(FALSE);
	// Call OnNewDocument() to reinitialize our only document.
	pDoc->OnNewDocument();
	// Set the document year to the zero based value selected in the combo box plus 1970.
	pDoc->nYear = m_Year.GetCurSel() + 1970;
	// Dump all data and invalidate the View.
	Clear_All();
	// Set our View flags to read new data.
	pDoc->fNewDoc++;
	pView->fEdit++;
	pView->fEvents++;
}

// Handler for the Full Height button.
void CCalendarDlg::OnVertf() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	// Set the calendar top and bottom sides equal to the printable page borders,
	// correcting for present client window size.
	pDoc->ratio_top = theApp.page_rect.top/pView->dCH;
	pDoc->ratio_bottom = theApp.page_rect.bottom/pView->dCH;
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}

// Handler for the Half Height button.
void CCalendarDlg::OnVerth() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	// Set the calendar height equal to half the printable page height.
	pView->m_calendar.m_rect.top = pView->m_calendar.m_rect.bottom -
					theApp.page_rect.Height()/2;
	// Set the document ratio to the new value, correcting for present client window size.
	pDoc->ratio_top = pView->m_calendar.m_rect.top/pView->dCH;
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for the Day Numbers Right/Left button.
void CCalendarDlg::OnWkdswap() 
{
	CMainFrame* pMain = theApp.Main_Pointer();

	// Check the current status and change it,
	// updating the button text accordingly.
	if(theApp.nDt_Swap == DT_RIGHT)
	{
		theApp.nDt_Swap = DT_LEFT;
		m_wkdSwap.SetWindowText("Right");
	}
	else
	{
		theApp.nDt_Swap = DT_RIGHT;
		m_wkdSwap.SetWindowText("Left");
	}
	// Set our fEdit flag so the Day Notes edit box gets updated.
	theApp.View_Pointer()->fEdit++;
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
	// Write the button status to DaysEase.ini.
	theApp.WriteProfileInt("DaysEase", "Day Swap", theApp.nDt_Swap);
}

// Determine the maximum text that can fit in the current Day Box size.
void CCalendarDlg::Check_DayNote_Text()
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	CString New_Data;
	CString eol = CString(0x0d) + CString(0x0a);
	int count(0), start, end;

	// Get the text from the edit box.
	m_Data.GetWindowText(New_Data);
	// Get rid of any Ctrl + Backspace character that the user may type.
	if(New_Data.Find(CString(0x7f)) != -1)
	{
		New_Data = New_Data.Mid(0, New_Data.Find(CString(0x7f))) + New_Data.Mid(New_Data.Find(CString(0x7f)) +1);
		m_Data.SetWindowText(New_Data);
	}
	CString tmp(New_Data + theApp.m_Eventgrid[pView->nCurX][pView->nCurY]);
	if((New_Data + theApp.m_Eventgrid[pView->nCurX][pView->nCurY]).GetLength() > MAX_NOTE)
	{
		m_Data.GetSel(start, end);
		if(end > 0)
		{
			if(New_Data.GetAt(end -1) == CString(0x0a))
				New_Data = New_Data.Mid(0, end -2) + New_Data.Mid(end);
			else
				New_Data = New_Data.Mid(0, end -1) + New_Data.Mid(end);
		}
		m_TextCheck.SetWindowText(New_Data + theApp.m_Eventgrid[pView->nCurX][pView->nCurY]);
		m_TextCheck.ShowWindow(SW_SHOW);
		MessageBox("Day Note full.", "DaysEase", MB_OK|MB_ICONEXCLAMATION);
		m_TextCheck.ShowWindow(SW_HIDE);
		while((New_Data + theApp.m_Eventgrid[pView->nCurX][pView->nCurY]).GetLength() > MAX_NOTE)
		{
			if(New_Data.IsEmpty())
				break;
			New_Data = New_Data.Mid(0, New_Data.GetLength() -1);
		}
		m_Data.SetWindowText(New_Data);
		m_Data.SetSel(start -1, start -1, FALSE);
	}
	while(tmp.Find(eol) != -1)
	{
		tmp = tmp.Mid(tmp.Find(eol) +2);
		count++;
	}
	if(count > 8)
	{
		m_Data.GetSel(start, end);
		if(end > 0)
		{
			if(New_Data.GetAt(end -1) == CString(0x0a))
				New_Data = New_Data.Mid(0, end -2) + New_Data.Mid(end);
			else
				New_Data = New_Data.Mid(0, New_Data.ReverseFind(char(0x0a) -2)) + 
					New_Data.Mid(New_Data.ReverseFind(char(0x0a)));
		}
		m_TextCheck.SetWindowText(New_Data + theApp.m_Eventgrid[pView->nCurX][pView->nCurY]);
		m_TextCheck.ShowWindow(SW_SHOW);
		MessageBox("No more lines available for Day Note.", "DaysEase",
			MB_OK|MB_ICONEXCLAMATION);
		m_TextCheck.ShowWindow(SW_HIDE);
		m_Data.SetWindowText(New_Data);
	}
}
// Dummy handler.
void CCalendarDlg::OnCancel()
{
	// Do nothing, so that the window doesn't disappear when the user presses Esc.
}
// Handler for Day Notes Cancel button.
void CCalendarDlg::OnCancelnote() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();
	
	// Overwite the edit box with the text from the currently selected Day Box.
	if(theApp.nDt_Swap == DT_RIGHT) // Include tab character if needed
		m_Data.SetWindowText(CString(0x09) + pDoc->GetSquare(pView->nCurX, pView->nCurY));
	else
		m_Data.SetWindowText(pDoc->GetSquare(pView->nCurX, pView->nCurY));
}
// Dummy handler.
void CCalendarDlg::OnOK()
{
	// Do nothing, so that the window doesn't disappear when the user presses Enter.
}

void CCalendarDlg::OnMaxtextData() 
{
	CDaysEaseView* pView = theApp.View_Pointer();
	CString string;

	m_Data.GetWindowText(string);
	string += theApp.m_Eventgrid[pView->nCurX][pView->nCurY];
	m_TextCheck.SetWindowText(string);
	m_TextCheck.ShowWindow(SW_SHOW);
	MessageBox("Day Note full.", "DaysEase", MB_OK|MB_ICONEXCLAMATION);
	m_TextCheck.ShowWindow(SW_HIDE);
}
