// ChooseCalcDate.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "ChooseCalcDate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CChooseCalcDate dialog


CChooseCalcDate::CChooseCalcDate(CWnd* pParent /*=NULL*/)
	: CDialog(CChooseCalcDate::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChooseCalcDate)
	//}}AFX_DATA_INIT
}


void CChooseCalcDate::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChooseCalcDate)
	DDX_Control(pDX, IDC_JAN, m_Jan);
	DDX_Control(pDX, IDC_MON, m_Mon);
	DDX_Control(pDX, IDC_1ST, m_1st);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChooseCalcDate, CDialog)
	//{{AFX_MSG_MAP(CChooseCalcDate)
	ON_BN_CLICKED(IDC_1ST, On1st)
	ON_BN_CLICKED(IDC_MON, OnMon)
	ON_BN_CLICKED(IDC_JAN, OnJan)
	ON_BN_CLICKED(IDC_2ND, On2nd)
	ON_BN_CLICKED(IDC_3RD, On3rd)
	ON_BN_CLICKED(IDC_4TH, On4th)
	ON_BN_CLICKED(IDC_APR, OnApr)
	ON_BN_CLICKED(IDC_AUG, OnAug)
	ON_BN_CLICKED(IDC_DEC, OnDec)
	ON_BN_CLICKED(IDC_FEB, OnFeb)
	ON_BN_CLICKED(IDC_FRI, OnFri)
	ON_BN_CLICKED(IDC_JUL, OnJul)
	ON_BN_CLICKED(IDC_JUN, OnJun)
	ON_BN_CLICKED(IDC_LAST, OnLast)
	ON_BN_CLICKED(IDC_MAR, OnMar)
	ON_BN_CLICKED(IDC_MAY, OnMay)
	ON_BN_CLICKED(IDC_NOV, OnNov)
	ON_BN_CLICKED(IDC_OCT, OnOct)
	ON_BN_CLICKED(IDC_SAT, OnSat)
	ON_BN_CLICKED(IDC_SEP, OnSep)
	ON_BN_CLICKED(IDC_SUN, OnSun)
	ON_BN_CLICKED(IDC_THU, OnThu)
	ON_BN_CLICKED(IDC_TUE, OnTue)
	ON_BN_CLICKED(IDC_WED, OnWed)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChooseCalcDate message handlers

void CChooseCalcDate::On1st() 
{
	Event_Changed(1, "1st");
}

void CChooseCalcDate::OnMon() 
{
	Event_Changed(2, " Monday ");
}

void CChooseCalcDate::Event_Changed(UINT index, CString word)
{
	theApp.EventDate[index] = word;
	for(int i = 1; i < 4; i++)
		m_SaveState[i] = theApp.EventDate[i];
	theApp.EventDate[0] = m_SaveState[0] = m_SaveState[3].Mid(3, 3) + "-" + 
		m_SaveState[2].Mid(1, 3) + " #" + m_SaveState[1].Left(1);
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, NULL, NULL);
}

void CChooseCalcDate::OnJan() 
{
	Event_Changed(3, "in January");
}

void CChooseCalcDate::On2nd() 
{
	Event_Changed(1, "2nd");
}

void CChooseCalcDate::On3rd() 
{
	Event_Changed(1, "3rd");
}

void CChooseCalcDate::On4th() 
{
	Event_Changed(1, "4th");
}

void CChooseCalcDate::OnApr() 
{
	Event_Changed(3, "in April");
}

void CChooseCalcDate::OnAug() 
{
	Event_Changed(3, "in August");
}

void CChooseCalcDate::OnDec() 
{
	Event_Changed(3, "in December");
}

void CChooseCalcDate::OnFeb() 
{
	Event_Changed(3, "in February");
}

void CChooseCalcDate::OnFri() 
{
	Event_Changed(2, " Friday ");
}

void CChooseCalcDate::OnJul() 
{
	Event_Changed(3, "in July");
}

void CChooseCalcDate::OnJun() 
{
	Event_Changed(3, "in June");
}

void CChooseCalcDate::OnLast() 
{
	Event_Changed(1, "Last");
}

void CChooseCalcDate::OnMar() 
{
	Event_Changed(3, "in March");
}

void CChooseCalcDate::OnMay() 
{
	Event_Changed(3, "in May");
}

void CChooseCalcDate::OnNov() 
{
	Event_Changed(3, "in November");
}

void CChooseCalcDate::OnOct() 
{
	Event_Changed(3, "in October");
}

void CChooseCalcDate::OnSat() 
{
	Event_Changed(2, " Saturday ");
}

void CChooseCalcDate::OnSep() 
{
	Event_Changed(3, "in September");
}

void CChooseCalcDate::OnSun() 
{
	Event_Changed(2, " Sunday ");
}

void CChooseCalcDate::OnThu() 
{
	Event_Changed(2, " Thursday ");
}

void CChooseCalcDate::OnTue() 
{
	Event_Changed(2, " Tuesday ");
}

void CChooseCalcDate::OnWed() 
{
	Event_Changed(2, " Wednesday ");
}

BOOL CChooseCalcDate::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_1st.SetCheck(1);
	m_Mon.SetCheck(1);
	m_Jan.SetCheck(1);
	m_SaveState[1] = "1st";
	m_SaveState[2] = " Monday ";
	m_SaveState[3] = "in January";
	m_SaveState[0] = m_SaveState[3].Mid(3, 3) + "-" + 
		m_SaveState[2].Mid(1, 3) + " #" + m_SaveState[1].Left(1);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChooseCalcDate::OnOK()
{
	// Do nothing, so that the window doesn't disappear when the user presses Enter.
}

void CChooseCalcDate::OnCancel()
{
	// Do nothing, so that the window doesn't disappear when the user presses Esc.
}
