// ChooseDateDlg.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "ChooseDateDlg.h"
#include "MainFrm.h"
#include "DaysEaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CChooseDateDlg dialog


CChooseDateDlg::CChooseDateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChooseDateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChooseDateDlg)
	m_EventCaption = _T("");
	m_Selected = _T("");
	//}}AFX_DATA_INIT
}


void CChooseDateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChooseDateDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDC_APPLY, m_Apply);
	DDX_Text(pDX, IDC_EVENTCAPTION, m_EventCaption);
	DDX_Text(pDX, IDC_SELECTED, m_Selected);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChooseDateDlg, CDialog)
	//{{AFX_MSG_MAP(CChooseDateDlg)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_EN_CHANGE(IDC_EVENTCAPTION, OnChangeEventcaption)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TABCHOOSE, OnSelchangeTabchoose)
	ON_NOTIFY(TCN_SELCHANGING, IDC_TABCHOOSE, OnSelchangingTabchoose)
	//}}AFX_MSG_MAP
	ON_MESSAGE (WM_MY_DATE_CHANGED, OnDateChanged)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChooseDateDlg message handlers

void CChooseDateDlg::Enable_Disable_Apply()
{
	CMainFrame* pMain = theApp.Main_Pointer();
	CString text("");

	// If the Event Caption string is already listed in the Event List...
	if(pMain->m_EventsDlg.m_EventList.FindStringExact(-1, theApp.EventDate[0] + (char)0x09 + m_EventCaption) != LB_ERR)
	{
		if(!m_EventCaption.IsEmpty())
			text = " already listed";
		// Disable the Apply and OK buttons.
		m_Apply.EnableWindow(FALSE);
		m_OK.EnableWindow(FALSE);
	}
	else
	{
		// If the user deleted the caption, disable the Apply and OK buttons.
		if(m_EventCaption.IsEmpty())
		{
			m_Apply.EnableWindow(FALSE);
			m_OK.EnableWindow(FALSE);
		}
		// Otherwise this is a new event, so enable the buttons.
		else
		{
			m_Apply.EnableWindow(TRUE);
			m_OK.EnableWindow(TRUE);
		}
	}
	// Set the status bar second pane either empty or to " already listed."
	pMain->m_wndStatusBar.SetPaneText(1, text);
}
// Handle our WM_MY_DATE_CHANGED message.
void CChooseDateDlg::OnDateChanged(UINT wParam, LPARAM lParam)
{
	m_Selected = theApp.EventDate[1] +  theApp.EventDate[2] + theApp.EventDate[3];
	// When wParam = 2 the caption is changed to "multiple selection."
	if(wParam == 2)
		m_EventCaption = theApp.EventDate[1];
	// Update the Event Caption box and the static box at the top of the dialog.
	UpdateData(FALSE);
	// Check to see if the Apply and OK button should be enabled.
	Enable_Disable_Apply();
}
// Handler for the Apply button.
void CChooseDateDlg::OnApply() 
{
	CMainFrame* pMain = theApp.Main_Pointer();
	BOOL trufal(TRUE);

	// If we are working with the Holidays page, we may have multiple selections.
	if(m_ChooseHolidays.IsWindowVisible())
	{
		int rgIndex[20];
		int count;
		CString text;

		count = m_ChooseHolidays.m_ListHolidays.GetSelItems(20, rgIndex);
		for(int i = 0; i < count; i++)
		{
			// Get each selected item and remove extra tab characters.
			m_ChooseHolidays.m_ListHolidays.GetText(rgIndex[i], text);
			theApp.EventDate[0] = text.Mid(0, text.Find((char)0x09));
			// Set the Event Caption, which may be "multiple selections" or not, if there's just one.
			m_EventCaption = text.Mid(text.ReverseFind((char)0x09) + 1);
			// Send our WM_MY_UPDATE_EVENTS message to the Events page dialog and wait for return.
			// The handler returns FALSE if successful.
			trufal = pMain->m_EventsDlg.SendMessage(WM_MY_UPDATE_EVENTS, NULL, NULL);
		}
		// Clear the selected items from the Holidays page.
		m_ChooseHolidays.m_ListHolidays.SetSel(-1, FALSE);
		// Clear the static box at the top of the dialog.
		m_Selected.Empty();
	}
	// If trufal is FALSE, then we've already sent our WM_MY_UPDATE_EVENTS message, so don't send again.
	if(trufal)
		pMain->m_EventsDlg.SendMessage(WM_MY_UPDATE_EVENTS, NULL, NULL);
	// Clear the Event Caption variable.
	m_EventCaption.Empty();
	// Update the Event Caption box and the static box at the top of the dialog.
	UpdateData(FALSE);
	// Let this function disable the Apply and OK buttons.
	Enable_Disable_Apply();
}

void CChooseDateDlg::OnChangeEventcaption() 
{
	// Get the Event Caption box text.
	UpdateData(TRUE);
	// Check to see if the Apply and OK button should be enabled.
	Enable_Disable_Apply();
}

void CChooseDateDlg::OnSelchangeTabchoose(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CRect rect;
	int i;

	// Hide all the pages.
	m_ChooseCalcDate.ShowWindow(SW_HIDE);
	m_ChooseSpecificDate.ShowWindow(SW_HIDE);
	m_ChooseHolidays.ShowWindow(SW_HIDE);

	// TabCtrl_GetCurSel() macro returns zero based integer of selected tab item.
	switch(TabCtrl_GetCurSel(pNMHDR->hwndFrom))
	{
	case 0:
		// Set the EventDate variables to the page m_SaveState variables.
		for(i = 0; i < 4; i++)
			theApp.EventDate[i] = m_ChooseSpecificDate.m_SaveState[i];
		// If the Annual box is checked, we don't want the year variable.
		if(m_ChooseSpecificDate.m_Annual.GetCheck())
			theApp.EventDate[3].Empty();
		// Show the page.
		m_ChooseSpecificDate.ShowWindow(SW_SHOW);
		// Update the static box at the top of the dialog.
		PostMessage(WM_MY_DATE_CHANGED, 0, NULL);
		break;
	case 1:
		// Set the EventDate variables to the page m_SaveState variables.
		for(i = 0; i < 4; i++)
			theApp.EventDate[i] = m_ChooseCalcDate.m_SaveState[i];
		// Show the page.
		m_ChooseCalcDate.ShowWindow(SW_SHOW);
		// Update the static box at the top of the dialog.
		PostMessage(WM_MY_DATE_CHANGED, 1, NULL);
		break;
	case 2:
		// Set the EventDate variables to the page m_SaveState variables.
		for(i = 0; i < 4; i++)
			theApp.EventDate[i] = m_ChooseHolidays.m_SaveState[i];
		// Show the page.
		m_ChooseHolidays.ShowWindow(SW_SHOW);
		// Take care of multiple selections.
		m_ChooseHolidays.List_Selected_Holidays();
	}
	
	*pResult = 0;
}

void CChooseDateDlg::OnSelchangingTabchoose(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Null the Event Caption before changing to the Holidays page.
	if(TabCtrl_GetCurSel(pNMHDR->hwndFrom) == 2)
		m_EventCaption.Empty();
	
	*pResult = 0;
}

BOOL CChooseDateDlg::OnInitDialog() 
{
	CDaysEaseView* pView = theApp.View_Pointer();
	CDialog::OnInitDialog();
	CRect dlgrect, rect;
	TC_ITEM TabCtrlItem;

	// Position the dialog over the View window to the left of the tabbed pages.
	// Get the ChooseDate dialog rectangle.
	GetWindowRect(dlgrect);
	// Get the main window client area rectangle.
	pView->GetClientRect(rect);
	// Convert it to screen coordinates.
	pView->ClientToScreen(rect);
	// Modify the rectangle so that it's the same size as the ChooseDate dialog
	// while keeping the top and right dimensions.
	rect.left = rect.right - dlgrect.Width();
	rect.bottom = rect.top + dlgrect.Height();
	// Move the ChooseDate dialog to this rectangle position.
	MoveWindow(rect, FALSE);

	// Create the tabbed pages.
	TabCtrlItem.mask = TCIF_TEXT;
	LPSTR item[3] = {"Specific Date", "Calculated Date", "Holidays"};
	CTabCtrl* pTabCtrl;
	pTabCtrl = ((CTabCtrl*)GetDlgItem(IDC_TABCHOOSE));
	for(int j=0; j<3; j++)
	{
		TabCtrlItem.pszText = item[j];
		pTabCtrl->InsertItem( j, &TabCtrlItem );
	}
	// Get the tab control client rectangle, including tabs and borders.
	pTabCtrl->GetClientRect(rect);
	// Pass the tab control's client rectangle to AdjustRect() with the first parameter FALSE.
	// It returns the rectangle of the tab control's display area in rect.
	pTabCtrl->AdjustRect(FALSE, rect);
	// Now create the pages and move them into the display rectangle position.
	m_ChooseSpecificDate.Create(IDD_CHOOSESPECDATE, pTabCtrl);
	m_ChooseSpecificDate.MoveWindow(rect, FALSE);
	m_ChooseCalcDate.Create(IDD_CHOOSECALCDATE, pTabCtrl);
	m_ChooseCalcDate.MoveWindow(rect, FALSE);
	m_ChooseHolidays.Create(IDD_CHOOSEHOLIDAYS, pTabCtrl);
	m_ChooseHolidays.MoveWindow(rect, FALSE);
	// Show the "Specific Date" by default.
	m_ChooseSpecificDate.ShowWindow(SW_SHOW);
	// Make sure that the Event Caption doesn't contain any garbage.
	m_EventCaption.Empty();
	// Limit the Event Caption text length.
	((CEdit*)GetDlgItem(IDC_EVENTCAPTION))->LimitText(30);
	// Let the OnDateChanged() message handler finish the initialization.
	PostMessage(WM_MY_DATE_CHANGED, 1, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChooseDateDlg::OnOK() 
{
	// If we have an Event Caption, call the Apply button handler directly before closing the dialog.
	if(!m_EventCaption.IsEmpty())
		OnApply();
	
	CDialog::OnOK();
}
