// ChooseHolidays.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "ChooseHolidays.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CChooseHolidays dialog


CChooseHolidays::CChooseHolidays(CWnd* pParent /*=NULL*/)
	: CDialog(CChooseHolidays::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChooseHolidays)
	//}}AFX_DATA_INIT
	
}


void CChooseHolidays::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChooseHolidays)
	DDX_Control(pDX, IDC_LISTHOLIDAYS, m_ListHolidays);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChooseHolidays, CDialog)
	//{{AFX_MSG_MAP(CChooseHolidays)
	ON_LBN_DBLCLK(IDC_LISTHOLIDAYS, OnDblclkListholidays)
	ON_LBN_SELCHANGE(IDC_LISTHOLIDAYS, OnSelchangeListholidays)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChooseHolidays message handlers

BOOL CChooseHolidays::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Initialize the dates.
	CString HolidayDates[20] =
	{"Jan 01",
   "Jan-Mon #3",  // third Monday in January
   "Feb 02",
   "Feb 14",
   "Feb-Mon #3",  // third Monday in February
   "Mar 17",
   "Apr 01",
   "EASTER",  // Special
   "May 01",
   "May-Sun #2",  // second sunday in May
   "May-Mon #L",  // last monday in May
   "Jun 14",
   "Jun-Sun #3",  // third sunday in June
   "Jul 04",
   "Sep-Mon #1",   // first monday in September
   "Oct-Mon #2",  // second monday in October
   "Oct 31",
   "Nov 11",
   "Nov-Thu #4",  // fourth thursday in November
   "Dec 25"};

	// Initialize the holiday captions.
	CString HolidayDescriptions[20] =
	{"New Year's Day",                      // always 1/1
   "Martin Luther King Jr",
   "Groundhog Day",                        // always 2/2
   "Valentine's Day",                     // always 2/14
   "Presidents Day",
   "St. Patrick's Day",                   // always 3/17
   "April Fool's Day",                    // always 4/1
   "Easter",
   "May Day",                              // always 5/1
   "Mother's Day",
   "Memorial Day",
   "Flag Day",                             // always 6/14
   "Father's Day",
   "Independence Day",                     // always 7/4
   "Labor Day",
   "Columbus Day",
   "Halloween",                            // always 10/31
   "Veterans Day",                         // always 11/11
   "Thanksgiving Day",
   "Christmas Day"};                       // always 12/25

	// Fill the Holiday list box.
	for(int i = 0; i < 20; i++)
	{
		m_ListHolidays.InsertString(i, HolidayDates[i] + (char)0x09 +
			HolidayDescriptions[i]);
	}
	// Set a tab stop so the dates and captions come out in columns.
	m_ListHolidays.SetTabStops(60);
	// Null the m_SaveState variables.
	for(i = 0; i < 4; i++)
			m_SaveState[i].Empty();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChooseHolidays::OnSelchangeListholidays() 
{
	List_Selected_Holidays();
}

void CChooseHolidays::OnDblclkListholidays() 
{
	CMainFrame* pMain = theApp.Main_Pointer();

	// Double clicking a holiday closes the ChooseDate dialog.
	pMain->m_EventsDlg.m_ChooseDateDlg.OnOK();
}

void CChooseHolidays::OnOK()
{
	// Do nothing, so that the window doesn't disappear when the user presses Enter.
}

void CChooseHolidays::OnCancel()
{
	// Do nothing, so that the window doesn't disappear when the user presses Esc.
}

void CChooseHolidays::List_Selected_Holidays()
{
	CString string;
	const int MAX = 100;
	int rgIndex[MAX];
	int count;

	// Fill the rgIndex with the selected item indexes.
	if((count = m_ListHolidays.GetSelItems(MAX, rgIndex)) != 1)
	{
		// Null the m_SaveState variables.
		for(int i = 0; i < 4; i++)
			m_SaveState[i].Empty();
	}
	// If only one item selected, configure the m_SaveState strings.
	if(count == 1)
	{
		m_ListHolidays.GetText(rgIndex[0], string);
		m_SaveState[0] = string.Mid(0, string.Find((char)0x09));
		m_SaveState[1] = string.Mid(string.ReverseFind((char)0x09) + 1);
		m_SaveState[2] = " (" + string.Mid(0, string.Find((char)0x09)) + ")";
	}
	// Otherwise, set only m_SaveState[1] to "multiple selection."
	else
	{
		m_SaveState[0].Empty();
		if(count != 0)
			m_SaveState[1] = "multiple selection";
		m_SaveState[2].Empty();
	}
	// Fill the EventDate strings with the m_SaveState strings
	for(int i = 0; i < 4; i++)
		theApp.EventDate[i] = m_SaveState[i];
	// Post the update message, to the ChooseDate dialog to set the caption.
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, 2, count);
}
