// DaysEase.cpp : Defines the class behaviors for the application.
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"

#include "MainFrm.h"
#include "DaysEaseDoc.h"
#include "DaysEaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaysEaseApp

BEGIN_MESSAGE_MAP(CDaysEaseApp, CWinApp)
	//{{AFX_MSG_MAP(CDaysEaseApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDaysEaseApp construction

CDaysEaseApp::CDaysEaseApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDaysEaseApp object

CDaysEaseApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDaysEaseApp initialization

BOOL CDaysEaseApp::InitInstance()
{
	//AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	//SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	TCHAR szHome[MAX_PATH];
	BOOL trufal(0);
	
	pDoc = NULL;
	pMain = NULL;
	pView = NULL;
	m_csCmdLineIni = m_lpCmdLine;;
	GetCurrentDirectory (sizeof(szHome) / sizeof(TCHAR), szHome);
	if(strlen(szHome) > 195)
		GetShortPathName(szHome, szHome, sizeof(szHome) / sizeof(TCHAR));
	m_csCurrentDir = szHome;
	if(m_csCurrentDir.Right(1) != "\\")
	{
		lstrcat(szHome, _T("\\"));
		m_csCurrentDir += "\\";
	}
	lstrcat(szHome, _T("DaysEase.ini"));
	// First free the string allocated by MFC at CWinApp startup
	// The string is allocated before InitInstance is called
	free((void*)m_pszProfileName);
	// Change the name of the .INI file
	// The CWinApp destructor will free the memory
	m_pszProfileName = _tcsdup(_T(szHome));
	if(m_csCmdLineIni.Find("/") != -1)
	{
		m_csCmdLineIni = m_csCmdLineIni.Mid(m_csCmdLineIni.Find("/") +1);
		if(m_csCmdLineIni.Left(1) == "\"")
			m_csCmdLineIni = m_csCmdLineIni.Mid(1);
		if(m_csCmdLineIni.Right(1) == "\"")
			m_csCmdLineIni = m_csCmdLineIni.Mid(0, m_csCmdLineIni.GetLength() -1);
		CString cmdline(m_csCmdLineIni);
		cmdline.MakeLower();
		if(cmdline.Find("uninst") != -1)
		{
			if(Uninstall())
				::MessageBox(NULL, "Not all DaysEase registry keys were deleted.\n\nSome may have already been deleted.",
					"DaysEase", MB_OK|MB_TOPMOST);
			else
				::MessageBox(NULL, "The DaysEase registry keys have been deleted.", "DaysEase",
					MB_OK|MB_TOPMOST);
			return FALSE;
		}
		if(cmdline.Right(4) == ".evn")
		{
			if(m_csCmdLineIni.GetAt(1) != ':' || m_csCmdLineIni.GetAt(2) != '\\')
					m_csCmdLineIni = m_csCurrentDir + m_csCmdLineIni;
		}
		else
			m_csCmdLineIni.Empty();
	}
	else
		m_csCmdLineIni.Empty();
	if((trufal = Read_Profile_Data()) == FALSE)
		return FALSE;

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDaysEaseDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDaysEaseView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	// Show the window maximized if it was maximized when last closed, otherwise show normally.
	m_pMainWnd->ShowWindow(GetProfileInt("DaysEase", "Show Window", SW_SHOW));
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Add our registry keys for the Event file icon
	Add_Reg_Keys();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDaysEaseApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDaysEaseApp commands

BOOL CDaysEaseApp::OnIdle(LONG lCount) 
{
	int start, end;

	// Update the status bar when not busy.
	if(pView->fGrafPos)
		pMain->m_wndStatusBar.SetPaneText(0, "Position graphic");
	if(pView->fCalPos)
		pMain->m_wndStatusBar.SetPaneText(0, "Position calendar");

	// Periodically, check to be sure the Day Notes edit box cursor doesn't wind up on the first line.
	pMain->m_CalendarDlg.m_Data.GetSel(start, end);
	if(pMain->m_CalendarDlg.m_Data.LineFromChar(start) == 0)
	{
		end = pMain->m_CalendarDlg.m_Data.LineIndex(1);
		end = pMain->m_CalendarDlg.m_Data.LineLength(end) + end;
		pMain->m_CalendarDlg.m_Data.SetSel(end, end);
	}
	// Update the View, periodically during window resizing.
	if(fSizing)
	{
		Update_View();
		fSizing = 0;
	}
	return CWinApp::OnIdle(lCount);
}

BOOL CDaysEaseApp::Read_Profile_Data()
{
	// See if any event file specified on the commandline exists and save it in DaysEase.ini if so.
	if(Verify_Event_File(m_csCmdLineIni))
		WriteProfileString("DaysEase", "Last Event File", m_csCmdLineIni);
	else  // If no valid event file on the commandline, see if the last one saved in DaysEase.ini is valid.
	{
		// If doesn't exist, clear the entry in DaysEase.ini.
		if(!Verify_Event_File(GetProfileString("DaysEase", "Last Event File", "")))
			WriteProfileString("DaysEase", "Last Event File", "");
		// We don't have a valid event file on the commandline, so empty the string.
		m_csCmdLineIni.Empty();
	}
// Check the DaysEase.ini file for the last printer
	PrinterName = GetProfileString("DaysEase", "Printer", "");
// Verify that the DaysEase.ini entry is valid for this machine by checking to see
	// if the printer is listed in the Win.ini [devices] section
	if(!PrinterName.IsEmpty())
	{
		CString TempData;
		::GetProfileString("devices", PrinterName, "",
			TempData.GetBuffer(MY_BUF_SIZE), MY_BUF_SIZE);
		TempData.ReleaseBuffer();
		if(TempData.IsEmpty())
		{// If not there, get rid of the Printer entry in DaysEase.ini
			PrinterName.Empty();
			WriteProfileString("DaysEase", "Printer", "");
		}
	}
// If no printer so far, get the default printer
	if(PrinterName.IsEmpty())
	{
		::GetProfileString("windows", "device", "",
			PrinterName.GetBuffer(MY_BUF_SIZE), MY_BUF_SIZE);
		PrinterName.ReleaseBuffer();
		if(PrinterName.Find(",") != -1)
			PrinterName = PrinterName.Mid(0, PrinterName.Find(","));
	}
// If still no valid printer, bail out, we can't run without one.
	if(PrinterName.IsEmpty())
	{
		::MessageBox(NULL, "No default printer installed.", "DaysEase",
			MB_OK|MB_TOPMOST);
		return FALSE;
		
	}
// Get user preferences for this printer, or assume defaults, (last argument)
	Orientation = GetProfileInt(PrinterName, "Orientation", DMORIENT_LANDSCAPE);
	PaperSize = GetProfileInt(PrinterName, "Paper Size", DMPAPER_LETTER);
	PrintColor = GetProfileInt(PrinterName, "Print Color", DMCOLOR_MONOCHROME);
// Get DaysEase user preferences, or assume defaults, (last argument)
	nDt_Swap = GetProfileInt("DaysEase", "Day Swap", DT_LEFT);
	csWkdayFont = GetProfileString("DaysEase", "Weekday Font", "Arial");
	WkdayColor = GetProfileInt("DaysEase", "Weekday Color", 0);
	WkdayWeight = GetProfileInt("DaysEase", "Weekday Weight", 400);
	WkdayItalic = GetProfileInt("DaysEase", "Weekday Italic", 0);
	csNotesFont = GetProfileString("DaysEase", "Notes Font", "Arial");
	NotesColor = GetProfileInt("DaysEase", "Notes Color", 0);
	NotesWeight = GetProfileInt("DaysEase", "Notes Weight", 400);
	NotesItalic = GetProfileInt("DaysEase", "Notes Italic", 0);
	nNoteLarge = GetProfileInt("DaysEase", "Note Size", 1);
	csTitleFont = GetProfileString("DaysEase", "Title Font", "Arial");
	TitleColor = GetProfileInt("DaysEase", "Title Color", 0);
	TitleWeight = GetProfileInt("DaysEase", "Title Weight", 400);
	TitleItalic = GetProfileInt("DaysEase", "Title Italic", 0);
	csDateFont = GetProfileString("DaysEase", "Date Font", "Arial");
	DateColor = GetProfileInt("DaysEase", "Date Color", 0);
	DateWeight = GetProfileInt("DaysEase", "Date Weight", 400);
	DateItalic = GetProfileInt("DaysEase", "Date Italic", 0);
	nDateLarge = GetProfileInt("DaysEase", "Date Size", 0);
	nDateSwap = GetProfileInt("DaysEase", "Date Swap", 0);
// Empty the Event List, so it doesn't contain any garbage characters
	csEventList.Empty();
	WriteProfileString("DaysEase", "Month Doc", "");
	WriteProfileString("DaysEase", "Year Doc", "");
	return TRUE;
}

void CDaysEaseApp::Add_Reg_Keys()
{
// Register an icon for the Event files
	DWORD dwData;
	HKEY myKey;
	CString value("DaysEase.Eventfile");

// Associate the file type to the extension
	RegCreateKeyEx(HKEY_CLASSES_ROOT, ".evn", 0, NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &myKey, &dwData);
	RegSetValueEx(myKey, NULL, 0, REG_SZ, (LPBYTE)(LPCTSTR)value,
		value.GetLength() + 1);
	RegCloseKey(myKey);
// Get the DaysEase.exe path from the existing document icon registry entry
	RegCreateKeyEx(HKEY_CLASSES_ROOT, "DaysEase.Document\\DefaultIcon", 0, NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &myKey, &dwData);
// Get the length of the path data
	RegQueryValueEx(myKey, NULL, NULL, NULL, NULL, &dwData);
// Now get the data
	RegQueryValueEx(myKey, NULL, NULL, NULL,
		(LPBYTE)value.GetBuffer(dwData), &dwData);
	RegCloseKey(myKey);
// Replace the document icon index with the Event icon index
	value.ReleaseBuffer();
	value.SetAt(value.GetLength() -1, '2');
// Create the Eventfile DefaultIcon key
	RegCreateKeyEx(HKEY_CLASSES_ROOT, "DaysEase.Eventfile\\DefaultIcon", 0, NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &myKey, &dwData);
// Set the path with the new icon index
	RegSetValueEx(myKey, NULL, 0, REG_SZ, (LPBYTE)(LPCTSTR)value,
		value.GetLength() + 1);
	RegCloseKey(myKey);

// Remove the .DEC extension from the Explorer New menu
	RegDeleteKey(HKEY_CLASSES_ROOT, ".dec\\ShellNew");

}

BOOL CDaysEaseApp::Uninstall()
{
	LONG result(0);

// Win NT requires that the subkeys be deleted first
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell\\printto\\command");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell\\printto");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell\\print\\command");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell\\print");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell\\open\\command");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell\\open");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\shell");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document\\DefaultIcon");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Eventfile\\DefaultIcon");
// Win 95/98 only requires these keys to be deleted
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Document");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, "DaysEase.Eventfile");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, ".dec");
	result += RegDeleteKey(HKEY_CLASSES_ROOT, ".evn");
// If no errors, result is still zero
	return result;
}

void CDaysEaseApp::Empty_Event_Array()
{
	for(int row = 0; row < 6; row++)
		for(int col = 0; col < 7; col++)
			theApp.m_Eventgrid[col][row].Empty();
	pView->fEvents++;
}

BOOL CDaysEaseApp::Verify_Event_File(CString filename)
{
	HANDLE find_handle = {NULL};
	WIN32_FIND_DATA find;

	find_handle = FindFirstFile(filename, &find);
	if(find_handle == INVALID_HANDLE_VALUE)
		return FALSE;
	else
		FindClose(find_handle);
	return TRUE;
}

void CDaysEaseApp::Update_View()
{
	pView->Invalidate();
}

void CDaysEaseApp::Set_Modified_Flag()
{
	pDoc->SetModifiedFlag();
}
