// StyleDlg.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "StyleDlg.h"
#include "DaysEaseDoc.h"
#include "DaysEaseView.h"
#include "FontDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CStyleDlg dialog


CStyleDlg::CStyleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStyleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStyleDlg)
	//}}AFX_DATA_INIT
}


void CStyleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStyleDlg)
	DDX_Control(pDX, IDC_SWAP, m_Swap);
	DDX_Control(pDX, IDC_RIGHT, m_Right);
	DDX_Control(pDX, IDC_LEFT, m_Left);
	DDX_Control(pDX, IDC_TITLE, m_Title);
	DDX_Control(pDX, IDC_CENTER, m_Center);
	DDX_Control(pDX, IDC_TITLELARGE, m_TitleLarge);
	DDX_Control(pDX, IDC_DATELARGE, m_DateLarge);
	DDX_Control(pDX, IDC_NOTELARGE, m_NoteLarge);
	DDX_Control(pDX, IDC_SPLIT, m_Split);
	DDX_Control(pDX, IDC_TEXT, m_Text);
	DDX_Control(pDX, IDC_WKDMONTH, m_wkdMonth);
	DDX_Control(pDX, IDC_MONYR, m_MonYr);
	DDX_Control(pDX, IDC_BTNDATE, m_btnDate);
	DDX_Control(pDX, IDC_BTNTITLE, m_btnTitle);
	DDX_Control(pDX, IDC_BTNDATA, m_btnData);
	DDX_Control(pDX, IDC_BTNWEEKDAY, m_btnWeekDay);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStyleDlg, CDialog)
	//{{AFX_MSG_MAP(CStyleDlg)
	ON_BN_CLICKED(IDC_BTNDATA, OnBtndata)
	ON_BN_CLICKED(IDC_BTNDATE, OnBtndate)
	ON_BN_CLICKED(IDC_BTNTITLE, OnBtntitle)
	ON_BN_CLICKED(IDC_BTNWEEKDAY, OnBtnweekday)
	ON_EN_CHANGE(IDC_TITLE, OnChangeTitle)
	ON_BN_CLICKED(IDC_DATELARGE, OnDatelarge)
	ON_BN_CLICKED(IDC_LEFT, OnLeft)
	ON_BN_CLICKED(IDC_NOTELARGE, OnNotelarge)
	ON_BN_CLICKED(IDC_RIGHT, OnRight)
	ON_BN_CLICKED(IDC_SPLIT, OnSplit)
	ON_BN_CLICKED(IDC_SWAP, OnSwap)
	ON_BN_CLICKED(IDC_TITLELARGE, OnTitlelarge)
	ON_BN_CLICKED(IDC_CENTER, OnCenter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStyleDlg message handlers

// Handler for Day Notes font
void CStyleDlg::OnBtndata() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();

	// Set the font height to a value that will be easy to see.
	pDoc->lfNotes.lfHeight = 18;
	// Create a new font dialog.
	CFontDlg* m_pfontdlg = new CFontDlg(&pDoc->lfNotes);
	// Set the color.
	m_pfontdlg->m_cf.rgbColors = theApp.NotesColor;
	// Set flags for True Type fonts only.
	m_pfontdlg->m_cf.Flags ^= CF_SCALABLEONLY | CF_SELECTSCRIPT;
	int nResponse = m_pfontdlg->DoModal();
	if (nResponse == IDOK)
	{
		// Save the new parameters.
		theApp.csNotesFont = pDoc->lfNotes.lfFaceName;
		theApp.NotesColor = m_pfontdlg->m_cf.rgbColors;
		theApp.NotesWeight = pDoc->lfNotes.lfWeight;
		theApp.NotesItalic = pDoc->lfNotes.lfItalic;
		// Set the document modified flag.
		theApp.Set_Modified_Flag();
		// Update the View.
		theApp.Update_View();
		// Save settings to DaysEase.ini.
		theApp.WriteProfileString("DaysEase", "Notes Font", theApp.csNotesFont);
		theApp.WriteProfileInt("DaysEase", "Notes Color", theApp.NotesColor);
		theApp.WriteProfileInt("DaysEase", "Notes Weight", theApp.NotesWeight);
		theApp.WriteProfileInt("DaysEase", "Notes Italic", theApp.NotesItalic);
	}
	// Delete the font dialog object.
	delete m_pfontdlg;
}
// Handler for Date font
void CStyleDlg::OnBtndate() 
{// Comments similar to above.
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();

	pDoc->lfDate.lfHeight = 18;
	CFontDlg* m_pfontdlg = new CFontDlg(&pDoc->lfDate);
	m_pfontdlg->m_cf.rgbColors = theApp.DateColor;
	m_pfontdlg->m_cf.Flags ^= CF_SCALABLEONLY | CF_SELECTSCRIPT;
	int nResponse = m_pfontdlg->DoModal();
	if (nResponse == IDOK)
	{
		theApp.csDateFont = pDoc->lfDate.lfFaceName;
		theApp.DateColor = m_pfontdlg->m_cf.rgbColors;
		theApp.DateWeight = pDoc->lfDate.lfWeight;
		theApp.DateItalic = pDoc->lfDate.lfItalic;
		theApp.Set_Modified_Flag();
		theApp.Update_View();
		theApp.WriteProfileString("DaysEase", "Date Font", theApp.csDateFont);
		theApp.WriteProfileInt("DaysEase", "Date Color", theApp.DateColor);
		theApp.WriteProfileInt("DaysEase", "Date Weight", theApp.DateWeight);
		theApp.WriteProfileInt("DaysEase", "Date Italic", theApp.DateItalic);
	}
	delete m_pfontdlg;
}
// Handler for Title font
void CStyleDlg::OnBtntitle() 
{// Comments similar to above.
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();

	pDoc->lfTitle.lfHeight = 18;
	CFontDlg* m_pfontdlg = new CFontDlg(&pDoc->lfTitle);
	m_pfontdlg->m_cf.rgbColors = theApp.TitleColor;
	m_pfontdlg->m_cf.Flags ^= CF_SCALABLEONLY | CF_SELECTSCRIPT;
	int nResponse = m_pfontdlg->DoModal();
	if (nResponse == IDOK)
	{
		theApp.csTitleFont = pDoc->lfTitle.lfFaceName;
		theApp.TitleColor = m_pfontdlg->m_cf.rgbColors;
		theApp.TitleWeight = pDoc->lfTitle.lfWeight;
		theApp.TitleItalic = pDoc->lfTitle.lfItalic;
		theApp.Set_Modified_Flag();
		theApp.Update_View();
		theApp.WriteProfileString("DaysEase", "Title Font", theApp.csTitleFont);
		theApp.WriteProfileInt("DaysEase", "Title Color", theApp.TitleColor);
		theApp.WriteProfileInt("DaysEase", "Title Weight", theApp.TitleWeight);
		theApp.WriteProfileInt("DaysEase", "Title Italic", theApp.TitleItalic);
	}
	delete m_pfontdlg;
}
// Handler for Week Day font
void CStyleDlg::OnBtnweekday() 
{// Comments similar to above.
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();

	pDoc->lfWeekday.lfHeight = 18;
	CFontDlg* m_pfontdlg = new CFontDlg(&pDoc->lfWeekday);
	m_pfontdlg->m_cf.rgbColors = theApp.WkdayColor;
	m_pfontdlg->m_cf.Flags ^= CF_SCALABLEONLY | CF_SELECTSCRIPT;
	int nResponse = m_pfontdlg->DoModal();
	if (nResponse == IDOK)
	{
		theApp.csWkdayFont = pDoc->lfWeekday.lfFaceName;
		theApp.WkdayColor = m_pfontdlg->m_cf.rgbColors;
		theApp.WkdayWeight = pDoc->lfWeekday.lfWeight;
		theApp.WkdayItalic = pDoc->lfWeekday.lfItalic;
		theApp.Set_Modified_Flag();
		theApp.Update_View();
		theApp.WriteProfileString("DaysEase", "Weekday Font", theApp.csWkdayFont);
		theApp.WriteProfileInt("DaysEase", "Weekday Color", theApp.WkdayColor);
		theApp.WriteProfileInt("DaysEase", "Weekday Weight", theApp.WkdayWeight);
		theApp.WriteProfileInt("DaysEase", "Weekday Italic", theApp.WkdayItalic);
	}
	delete m_pfontdlg;
}
// Handler for Title editbox
void CStyleDlg::OnChangeTitle() 
{
	CString New_Data;

	m_Title.GetWindowText(New_Data);
	// Get rid of any Ctrl + Backspace character that the user may type.
	if(New_Data.Find(CString(0x7f)) != -1)
	{
		New_Data = New_Data.Mid(0, New_Data.Find(CString(0x7f))) + New_Data.Mid(New_Data.Find(CString(0x7f)) +1);
		m_Title.SetWindowText(New_Data);
	}
	else
	{
		theApp.Set_Modified_Flag();
		Update_Title_Rect();
	}
}
// Handler for Date Large font checkbox
void CStyleDlg::OnDatelarge() 
{
	if(m_DateLarge.GetCheck())
		theApp.nDateLarge = 1;
	else
		theApp.nDateLarge = 0;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
	theApp.WriteProfileInt("DaysEase", "Date Size", theApp.nDateLarge);
}
// Handler for Left radio button
void CStyleDlg::OnLeft() 
{
	theApp.nDt_Custom = DT_LEFT;
	theApp.Set_Modified_Flag();
	Update_Title_Rect();
	theApp.WriteProfileInt("DaysEase", "Date Style", theApp.nDt_Custom);
}
// Handler for Day Note Large font checkbox
void CStyleDlg::OnNotelarge() 
{
	if(m_NoteLarge.GetCheck())
		theApp.nNoteLarge = 1;
	else
		theApp.nNoteLarge = 0;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
	theApp.WriteProfileInt("DaysEase", "Note Size", theApp.nNoteLarge);
}
// Handler for Right radio button
void CStyleDlg::OnRight() 
{
	theApp.nDt_Custom = DT_RIGHT;
	theApp.Set_Modified_Flag();
	Update_Title_Rect();
	theApp.WriteProfileInt("DaysEase", "Date Style", theApp.nDt_Custom);
}
// Handler for Split radio button
void CStyleDlg::OnSplit() 
{
	theApp.nDt_Custom = -1;
	theApp.Set_Modified_Flag();
	Update_Title_Rect();
	theApp.WriteProfileInt("DaysEase", "Date Style", theApp.nDt_Custom);
}
// Handler for Swap radio button
void CStyleDlg::OnSwap() 
{
	if(theApp.nDateSwap)
	{
		theApp.nDateSwap = 0;
		m_MonYr.SetWindowText("Month and Year");
	}
	else
	{
		theApp.nDateSwap = 1;
		m_MonYr.SetWindowText("Year and Month");
	}
	theApp.Set_Modified_Flag();
	Update_Title_Rect();
	theApp.WriteProfileInt("DaysEase", "Date Swap", theApp.nDateSwap);
}
// Handler for Title Large checkbox
void CStyleDlg::OnTitlelarge() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();

	if(m_TitleLarge.GetCheck())
		pDoc->nTitleLarge = 1;
	else
		pDoc->nTitleLarge = 0;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for Center radio button
void CStyleDlg::OnCenter() 
{
	theApp.nDt_Custom = DT_CENTER;
	theApp.Set_Modified_Flag();
	Update_Title_Rect();
	theApp.WriteProfileInt("DaysEase", "Date Style", theApp.nDt_Custom);
}
// Dummy handler
void CStyleDlg::OnCancel()
{
	// Do nothing, so that the window doesn't disappear when the user presses Esc.
}

BOOL CStyleDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Limit the amount of text for the user supplied title.
	m_Title.SetLimitText(32);
	
	return TRUE;
}
// Dummy handler
void CStyleDlg::OnOK()
{
	// Do nothing, so that the window doesn't disappear when the user presses Enter.
}
// Enables radio buttons
void CStyleDlg::Set_Date_Style()
{
	// Uncheck all radio buttons.
	m_Left.SetCheck(0);
	m_Center.SetCheck(0);
	m_Right.SetCheck(0);
	m_Split.SetCheck(0);
	// Set the one radio button according to the value of nDt_Custom.
	switch(theApp.nDt_Custom)
	{
	case DT_LEFT:
		m_Left.SetCheck(1);
		break;
	case DT_CENTER:
		m_Center.SetCheck(1);
		break;
	case DT_RIGHT:
		m_Right.SetCheck(1);
		break;
	case -1:
		m_Split.SetCheck(1);
	}
}

void CStyleDlg::Update_Title_Rect()
{
	theApp.View_Pointer()->InvalidateRect(theApp.View_Pointer()->crTitle);
}
